diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -1165,203 +1049,226 @@ deparse_ColumnDef_typed(Relation relation, List *dpcontext, ColumnDef *coldef)
 		}
 	}
 
+	if (notnull)
+		*notnull = saw_notnull;
+
 	if (!saw_notnull && !attrForm->atthasdef)
 	{
 		ReleaseSysCache(attrTup);
-		return NULL;
+		return false;
 	}
 
-	tmp_obj = new_objtree("DEFAULT");
+	ReleaseSysCache(attrTup);
+	return true;
+}
+
+/*
+ * Deparse a ColumnDef node within a typed table creation. This is simpler
+ * than the regular case, because we don't have to emit the type declaration,
+ * collation, or default. Here we only return something if the column is being
+ * declared NOT NULL.
+ *
+ * As in deparse_ColumnDef, any other constraint is processed elsewhere.
+ *
+ * Verbose syntax
+ * %{name}I WITH OPTIONS %{not_null}s %{default}s.
+ */
+static void
+deparse_ColumnDef_typed_toJsonb(JsonbParseState *state, Relation relation,
+								List *dpcontext, ColumnDef *coldef)
+{
+	char	   *fmtStr = "%{name}I WITH OPTIONS %{not_null}s %{default}s";
+	bool		needed;
+	Form_pg_attribute attrForm;
+	bool		saw_notnull;
+
+	needed = deparse_ColDef_typed_needed(relation, coldef, &attrForm, &saw_notnull);
+	if (!needed)
+		return;
+
+	/* start making column object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	fmt_to_jsonb_element(state, fmtStr);
+
+	/* Insert TYPE, NAME and NOT_NULL elements */
+	new_jsonb_VA(state, fmtStr, true, 3,
+				 "type", jbvString, "column",
+				 "name", jbvString, coldef->colname,
+				 "not_null", jbvString, saw_notnull ? "NOT NULL" : "");
+
+	/* DEFAULT: Push the key first */
+	insert_jsonb_key(state, "default");
+
+	/* DEFAULT: Push the value now */
 	if (attrForm->atthasdef)
 	{
 		char	   *defstr;
 
 		defstr = RelationGetColumnDefault(relation, attrForm->attnum,
 										  dpcontext, NULL);
-
-		append_string_object(tmp_obj, "%{default}s", "default", defstr);
+		new_jsonb_VA(state, "DEFAULT %{default}s", false, 1,
+					 "default", jbvString, defstr);
 	}
 	else
-		append_not_present(tmp_obj, "%{default}s");
+		insert_not_present_obj(state, verbose ? "DEFAULT %{default}s" : "DEFAULT");
 
-	ret = new_objtree_VA("%{name}I WITH OPTIONS %{not_null}s %{default}s", 4,
-						 "type", ObjTypeString, "column",
-						 "name", ObjTypeString, coldef->colname,
-						 "not_null", ObjTypeString,
-						 saw_notnull ? "NOT NULL" : "",
-						 "default", ObjTypeObject, tmp_obj);
+	/* mark the end of column object */
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
 	/* Generated columns are not supported on typed tables, so we are done */
 
-	ReleaseSysCache(attrTup);
-
-	return ret;
 }
 
 /*
- * Deparse the definition of column identity.
+ * Subroutine for CREATE TABLE deparsing.
  *
- * Verbose syntax
- * SET GENERATED %{option}s %{identity_type}s %{seq_definition: }s
- * 	OR
- * GENERATED %{option}s AS IDENTITY %{identity_type}s ( %{seq_definition: }s )
+ * Returns true if at-least one local column is present
+ * (i.e. not inherited).
  */
-static ObjTree *
-deparse_ColumnIdentity(Oid seqrelid, char identity, bool alter_table)
+static bool
+table_elem_present_col(Relation relation, List *tableElements, bool typed)
 {
-	ObjTree    *ret;
-	ObjTree    *ident_obj;
-	List	   *elems = NIL;
-	Form_pg_sequence seqform;
-	Sequence_values *seqvalues;
-	char	   *identfmt;
-	char	   *objfmt;
+	ListCell   *lc;
 
-	if (alter_table)
-	{
-		identfmt = "SET GENERATED ";
-		objfmt = "%{option}s";
-	}
-	else
+	foreach(lc, tableElements)
 	{
-		identfmt = "GENERATED ";
-		objfmt = "%{option}s AS IDENTITY";
-	}
-
-	ident_obj = new_objtree(identfmt);
-	if (identity == ATTRIBUTE_IDENTITY_ALWAYS)
-		append_string_object(ident_obj, objfmt, "option", "ALWAYS");
-	else if (identity == ATTRIBUTE_IDENTITY_BY_DEFAULT)
-		append_string_object(ident_obj, objfmt, "option", "BY DEFAULT");
-	else
-		append_not_present(ident_obj, objfmt);
-
-	ret = new_objtree_VA("%{identity_type}s", 1,
-						 "identity_type", ObjTypeObject, ident_obj);
-
-	seqvalues = get_sequence_values(seqrelid);
-	seqform = seqvalues->seqform;
-
-	/* Definition elements */
-	elems = lappend(elems, deparse_Seq_Cache(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_Cycle(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_IncrementBy(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_Minvalue(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_Maxvalue(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_Startwith(seqform, alter_table));
-	elems = lappend(elems, deparse_Seq_Restart(seqvalues->last_value));
-	/* We purposefully do not emit OWNED BY here */
+		Node	   *elt = (Node *) lfirst(lc);
 
-	if (alter_table)
-		append_array_object(ret, "%{seq_definition: }s", elems);
-	else
-		append_array_object(ret, "( %{seq_definition: }s )", elems);
+		switch (nodeTag(elt))
+		{
+			case T_ColumnDef:
+				{
+					if (typed)
+					{
+						if (deparse_ColDef_typed_needed(relation,
+														((ColumnDef *) elt), NULL, NULL))
+							return true;
+					}
+					else
+					{
+						if (((ColumnDef *) elt)->is_local)
+							return true;
+					}
+				}
+				break;
+			case T_Constraint:
+				break;
+			default:
+				elog(ERROR, "invalid node type %d", nodeTag(elt));
+		}
+	}
 
-	return ret;
+	return false;
 }
 
+
 /*
- * ... ALTER COLUMN ... SET/RESET (...)
+ * Subroutine for CREATE TABLE deparsing.
  *
- * Verbose syntax
- * ALTER COLUMN %{column}I RESET|SET (%{options:, }s)
+ * Returns true if at-least one constraint is present.
+ *
+ * Note that CONSTRAINT_FOREIGN constraints are always ignored.
  */
-static ObjTree *
-deparse_ColumnSetOptions(AlterTableCmd *subcmd)
+static bool
+table_elem_present_const(Oid relationId)
 {
-	List	   *sets = NIL;
-	ListCell   *cell;
-	ObjTree    *ret;
-	bool		is_reset = subcmd->subtype == AT_ResetOptions;
+	Relation	conRel;
+	ScanKeyData key;
+	SysScanDesc scan;
+	HeapTuple	tuple;
+	bool		bconst = false;
 
-	ret = new_objtree_VA("ALTER COLUMN %{column}I %{option}s", 2,
-						 "column", ObjTypeString, subcmd->name,
-						 "option", ObjTypeString, is_reset ? "RESET" : "SET");
+	Assert(OidIsValid(relationId));
 
-	foreach(cell, (List *) subcmd->def)
+	/*
+	 * Scan pg_constraint to fetch all constraints linked to the given
+	 * relation.
+	 */
+	conRel = table_open(ConstraintRelationId, AccessShareLock);
+	ScanKeyInit(&key, Anum_pg_constraint_conrelid, BTEqualStrategyNumber,
+				F_OIDEQ, ObjectIdGetDatum(relationId));
+	scan = systable_beginscan(conRel, ConstraintRelidTypidNameIndexId, true,
+							  NULL, 1, &key);
+
+	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		DefElem    *elem;
-		ObjTree    *set;
+		Form_pg_constraint constrForm;
 
-		elem = (DefElem *) lfirst(cell);
-		set = deparse_DefElem(elem, is_reset);
-		sets = lappend(sets, new_object_object(set));
+		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+
+		switch (constrForm->contype)
+		{
+			case CONSTRAINT_CHECK:
+			case CONSTRAINT_PRIMARY:
+			case CONSTRAINT_UNIQUE:
+			case CONSTRAINT_EXCLUSION:
+				bconst = true;
+				break;
+			case CONSTRAINT_FOREIGN:
+				continue;		/* not here */
+			default:
+				elog(ERROR, "unrecognized constraint type");
+		}
 	}
 
-	Assert(sets);
-	append_array_object(ret, "(%{options:, }s)", sets);
+	systable_endscan(scan);
+	table_close(conRel, AccessShareLock);
 
-	return ret;
+	return bconst;
 }
 
 /*
- * Deparse SET/RESET clause as used by ALTER TABLE ... SET/RESET (...)
+ * Subroutine for CREATE TABLE deparsing.
  *
- * Verbose syntax
- * RESET|SET (%{options:, }s)
+ * Deal with all the table elements (columns and constraints).
+ *
+ * Note we ignore constraints in the parse node here; they are extracted from
+ * system catalogs instead.
  */
-static ObjTree *
-deparse_RelSetOptions(AlterTableCmd *subcmd)
+
+static void
+deparse_TableElems_ToJsonb(JsonbParseState *state, Relation relation,
+						   List *tableElements, List *dpcontext,
+						   bool typed, bool composite)
 {
-	List	   *sets = NIL;
-	ListCell   *cell;
-	bool		is_reset = subcmd->subtype == AT_ResetRelOptions;
+	ListCell   *lc;
 
-	foreach(cell, (List *) subcmd->def)
+	foreach(lc, tableElements)
 	{
-		DefElem    *elem;
-		ObjTree    *set;
+		Node	   *elt = (Node *) lfirst(lc);
 
-		elem = (DefElem *) lfirst(cell);
-		set = deparse_DefElem(elem, is_reset);
-		sets = lappend(sets, new_object_object(set));
+		switch (nodeTag(elt))
+		{
+			case T_ColumnDef:
+				{
+					if (typed)
+						deparse_ColumnDef_typed_toJsonb(state, relation, dpcontext,
+														(ColumnDef *) elt);
+					else
+						deparse_ColumnDef_toJsonb(state, relation, dpcontext,
+												  composite, (ColumnDef *) elt,
+												  false, NULL);
+				}
+				break;
+			case T_Constraint:
+				break;
+			default:
+				elog(ERROR, "invalid node type %d", nodeTag(elt));
+		}
 	}
 
-	Assert(sets);
-
-	return new_objtree_VA("%{set_reset}s (%{options:, }s)", 2,
-						  "set_reset", ObjTypeString, is_reset ? "RESET" : "SET",
-						  "options", ObjTypeArray, sets);
 }
 
 /*
- * Deparse DefElems, as used e.g. by ALTER COLUMN ... SET, into a list of SET
- * (...)  or RESET (...) contents.
+ * Subroutine for CREATE TABLE deparsing.
  *
- * Verbose syntax
- * %{label}s = %{value}L
- */
-static ObjTree *
-deparse_DefElem(DefElem *elem, bool is_reset)
-{
-	ObjTree    *ret;
-	ObjTree    *optname = new_objtree("");
-
-	if (elem->defnamespace != NULL)
-		append_string_object(optname, "%{schema}I.", "schema",
-							 elem->defnamespace);
-
-	append_string_object(optname, "%{label}I", "label", elem->defname);
-
-	ret = new_objtree_VA("%{label}s", 1,
-						 "label", ObjTypeObject, optname);
-
-	if (!is_reset)
-		append_string_object(ret, "= %{value}L", "value",
-							 elem->arg ? defGetString(elem) :
-							 defGetBoolean(elem) ? "TRUE" : "FALSE");
-
-	return ret;
-}
-
-/*
  * Deparse the INHERITS relations.
  *
  * Given a table OID, return a schema-qualified table list representing
  * the parent tables.
  */
 static List *
-deparse_InhRelations(Oid objectId)
+deparse_InhRels_ToJsonb(Oid objectId)
 {
 	List	   *parents = NIL;
 	Relation	inhRel;
@@ -1381,12 +1288,9 @@ deparse_InhRelations(Oid objectId)
 
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		ObjTree    *parent;
 		Form_pg_inherits formInh = (Form_pg_inherits) GETSTRUCT(tuple);
 
-		parent = new_objtree_for_qualname_id(RelationRelationId,
-											 formInh->inhparent);
-		parents = lappend(parents, new_object_object(parent));
+		parents = lappend_oid(parents, formInh->inhparent);
 	}
 
 	systable_endscan(scan);
@@ -1396,445 +1300,338 @@ deparse_InhRelations(Oid objectId)
 }
 
 /*
- * Deparse the ON COMMIT ... clause for CREATE ... TEMPORARY ...
- *
- * Verbose syntax
- * ON COMMIT %{on_commit_value}s
- */
-static ObjTree *
-deparse_OnCommitClause(OnCommitAction option)
-{
-	ObjTree    *ret  = new_objtree("ON COMMIT");
-	switch (option)
-	{
-		case ONCOMMIT_DROP:
-			append_string_object(ret, "%{on_commit_value}s",
-								 "on_commit_value", "DROP");
-			break;
-
-		case ONCOMMIT_DELETE_ROWS:
-			append_string_object(ret, "%{on_commit_value}s",
-								 "on_commit_value", "DELETE ROWS");
-			break;
-
-		case ONCOMMIT_PRESERVE_ROWS:
-			append_string_object(ret, "%{on_commit_value}s",
-								 "on_commit_value", "PRESERVE ROWS");
-			break;
-
-		case ONCOMMIT_NOOP:
-			append_not_present(ret, "%{on_commit_value}s");
-			break;
-	}
-
-	return ret;
-}
-
-/*
- * Deparse the sequence CACHE option.
- *
- * Verbose syntax
- * SET CACHE %{value}s
- * OR
- * CACHE %{value}
- */
-static inline ObjElem *
-deparse_Seq_Cache(Form_pg_sequence seqdata, bool alter_table)
-{
-	ObjTree    *ret;
-	char	   *fmt;
-
-	fmt = alter_table ? "SET CACHE %{value}s" : "CACHE %{value}s";
-
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "cache",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, seqdata->seqcache));
-
-	return new_object_object(ret);
-}
-
-/*
- * Deparse the sequence CYCLE option.
- *
- * Verbose syntax
- * SET %{no}s CYCLE
- * OR
- * %{no}s CYCLE
- */
-static inline ObjElem *
-deparse_Seq_Cycle(Form_pg_sequence seqdata, bool alter_table)
-{
-	ObjTree    *ret;
-	char	   *fmt;
-
-	fmt = alter_table ? "SET %{no}s CYCLE" : "%{no}s CYCLE";
-
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "cycle",
-						 "no", ObjTypeString,
-						 seqdata->seqcycle ? "" : "NO");
-
-	return new_object_object(ret);
-}
-
-/*
- * Deparse the sequence INCREMENT BY option.
- *
- * Verbose syntax
- * SET INCREMENT BY %{value}s
- * OR
- * INCREMENT BY %{value}s
- */
-static inline ObjElem *
-deparse_Seq_IncrementBy(Form_pg_sequence seqdata, bool alter_table)
-{
-	ObjTree    *ret;
-	char	   *fmt;
-
-	fmt = alter_table ? "SET INCREMENT BY %{value}s" : "INCREMENT BY %{value}s";
-
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "seqincrement",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, seqdata->seqincrement));
-
-	return new_object_object(ret);
-}
-
-/*
- * Deparse the sequence MAXVALUE option.
+ * Subroutine for CREATE TABLE deparsing.
  *
- * Verbose syntax
- * SET MAXVALUE %{value}s
- * OR
- * MAXVALUE %{value}s
- */
-static inline ObjElem *
-deparse_Seq_Maxvalue(Form_pg_sequence seqdata, bool alter_table)
-{
-	ObjTree    *ret;
-	char	   *fmt;
-
-	fmt = alter_table ? "SET MAXVALUE %{value}s" : "MAXVALUE %{value}s";
-
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "maxvalue",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, seqdata->seqmax));
-
-	return new_object_object(ret);
-}
-
-/*
- * Deparse the sequence MINVALUE option.
+ * Given a table OID, obtain its constraints and append them to the given
+ * JsonbParseState.
  *
- * Verbose syntax
- * SET MINVALUE %{value}s
- * OR
- * MINVALUE %{value}s
- */
-static inline ObjElem *
-deparse_Seq_Minvalue(Form_pg_sequence seqdata, bool alter_table)
-{
-	ObjTree    *ret;
-	char	   *fmt;
-
-	fmt = alter_table ? "SET MINVALUE %{value}s" : "MINVALUE %{value}s";
-
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "minvalue",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, seqdata->seqmin));
-
-	return new_object_object(ret);
-}
-
-/*
- * Deparse the sequence OWNED BY command.
+ * This works for typed tables, regular tables.
  *
- * Verbose syntax
- * OWNED BY %{owner}D
+ * Note that CONSTRAINT_FOREIGN constraints are always ignored.
  */
-static ObjElem *
-deparse_Seq_OwnedBy(Oid sequenceId, bool alter_table)
+static void
+deparse_Constraints_ToJsonb(JsonbParseState *state, Oid relationId)
 {
-	ObjTree    *ret = NULL;
-	Relation	depRel;
+	Relation	conRel;
+	ScanKeyData key;
 	SysScanDesc scan;
-	ScanKeyData keys[3];
 	HeapTuple	tuple;
 
-	depRel = table_open(DependRelationId, AccessShareLock);
-	ScanKeyInit(&keys[0],
-				Anum_pg_depend_classid,
-				BTEqualStrategyNumber, F_OIDEQ,
-				ObjectIdGetDatum(RelationRelationId));
-	ScanKeyInit(&keys[1],
-				Anum_pg_depend_objid,
-				BTEqualStrategyNumber, F_OIDEQ,
-				ObjectIdGetDatum(sequenceId));
-	ScanKeyInit(&keys[2],
-				Anum_pg_depend_objsubid,
-				BTEqualStrategyNumber, F_INT4EQ,
-				Int32GetDatum(0));
+	Assert(OidIsValid(relationId));
 
-	scan = systable_beginscan(depRel, DependDependerIndexId, true,
-							  NULL, 3, keys);
+	/*
+	 * Scan pg_constraint to fetch all constraints linked to the given
+	 * relation.
+	 */
+	conRel = table_open(ConstraintRelationId, AccessShareLock);
+	ScanKeyInit(&key, Anum_pg_constraint_conrelid, BTEqualStrategyNumber,
+				F_OIDEQ, ObjectIdGetDatum(relationId));
+	scan = systable_beginscan(conRel, ConstraintRelidTypidNameIndexId, true,
+							  NULL, 1, &key);
+
+	/*
+	 * For each constraint, add a node to the list of table elements.  In
+	 * these nodes we include not only the printable information ("fmt"), but
+	 * also separate attributes to indicate the type of constraint, for
+	 * automatic processing.
+	 */
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		Oid			ownerId;
-		Form_pg_depend depform;
-		ObjTree    *tmp_obj;
-		char	   *colname;
+		Form_pg_constraint constrForm;
+		char	   *contype;
+		char	   *fmtStr = "CONSTRAINT %{name}I %{definition}s";
+
+		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+
+		switch (constrForm->contype)
+		{
+			case CONSTRAINT_CHECK:
+				contype = "check";
+				break;
+			case CONSTRAINT_FOREIGN:
+				continue;		/* not here */
+			case CONSTRAINT_PRIMARY:
+				contype = "primary key";
+				break;
+			case CONSTRAINT_UNIQUE:
+				contype = "unique";
+				break;
+			case CONSTRAINT_EXCLUSION:
+				contype = "exclusion";
+				break;
+			default:
+				elog(ERROR, "unrecognized constraint type");
+		}
+
+		/*
+		 * "type" and "contype" are not part of the printable output, but are
+		 * useful to programmatically distinguish these from columns and among
+		 * different constraint types.
+		 *
+		 * XXX it might be useful to also list the column names in a PK, etc.
+		 */
 
-		depform = (Form_pg_depend) GETSTRUCT(tuple);
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
 
-		/* Only consider AUTO dependencies on pg_class */
-		if (depform->deptype != DEPENDENCY_AUTO)
-			continue;
-		if (depform->refclassid != RelationRelationId)
-			continue;
-		if (depform->refobjsubid <= 0)
-			continue;
+		new_jsonb_VA(state, fmtStr, true, 4,
+					 "type", jbvString, "constraint",
+					 "contype", jbvString, contype,
+					 "name", jbvString, NameStr(constrForm->conname),
+					 "definition", jbvString,
+					 pg_get_constraintdef_string(constrForm->oid));
 
-		ownerId = depform->refobjid;
-		colname = get_attname(ownerId, depform->refobjsubid, false);
-		if (colname == NULL)
-			continue;
+		if (constrForm->conindid &&
+			(constrForm->contype == CONSTRAINT_PRIMARY ||
+			 constrForm->contype == CONSTRAINT_UNIQUE ||
+			 constrForm->contype == CONSTRAINT_EXCLUSION))
+		{
+			Oid			tblspc = get_rel_tablespace(constrForm->conindid);
+
+			if (OidIsValid(tblspc))
+			{
+				char	   *tblspcname = get_tablespace_name(tblspc);
 
-		tmp_obj = new_objtree_for_qualname_id(RelationRelationId, ownerId);
-		append_string_object(tmp_obj, "attrname", "attrname", colname);
-		ret = new_objtree_VA("OWNED BY %{owner}D", 2,
-							 "clause", ObjTypeString, "owned",
-							 "owner", ObjTypeObject, tmp_obj);
+				if (!tblspcname)
+					elog(ERROR, "cache lookup failed for tablespace %u", tblspc);
+
+				new_jsonb_VA(state, "USING INDEX TABLESPACE %{tblspc}s", true, 1,
+							 "tblspc", jbvString, tblspcname);
+			}
+		}
+
+		pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 	}
 
 	systable_endscan(scan);
-	relation_close(depRel, AccessShareLock);
-
-	/*
-	 * If there's no owner column, emit an empty OWNED BY element, set up so
-	 * that it won't print anything.
-	 */
-	if (!ret)
-		/* XXX this shouldn't happen ... */
-		ret = new_objtree_VA("OWNED BY %{owner}D", 3,
-							 "clause", ObjTypeString, "owned",
-							 "owner", ObjTypeNull,
-							 "present", ObjTypeBool, false);
-
-	return new_object_object(ret);
+	table_close(conRel, AccessShareLock);
 }
 
 /*
- * Deparse the sequence RESTART option.
+ * Deparse DefElems, as used by Create Table
  *
  * Verbose syntax
- * RESTART %{value}s
+ * %{label}s = %{value}L
  */
-static inline ObjElem *
-deparse_Seq_Restart(int64 last_value)
+static void
+deparse_DefElem_ToJsonb(JsonbParseState *state, DefElem *elem, bool is_reset)
 {
-	ObjTree    *ret;
+	StringInfoData fmtStr;
 
-	ret = new_objtree_VA("RESTART %{value}s", 2,
-						 "clause", ObjTypeString, "restart",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, last_value));
+	initStringInfo(&fmtStr);
 
-	return new_object_object(ret);
-}
+	appendStringInfoString(&fmtStr, "%{label}s");
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
 
-/*
- * Deparse the sequence AS option.
- *
- * Verbose syntax
- * AS %{seqtype}T
- */
-static inline ObjElem *
-deparse_Seq_As(Form_pg_sequence seqdata)
-{
-	ObjTree    *ret;
+	/* LABEL */
+	{
+		StringInfoData labelfmt;
 
-	ret = new_objtree("AS");
-	if (OidIsValid(seqdata->seqtypid))
-		append_object_object(ret, "%{seqtype}T",
-							 new_objtree_for_type(seqdata->seqtypid, -1));
-	else
-		append_not_present(ret, "%{seqtype}T");
+		initStringInfo(&labelfmt);
+
+		/* insert LABEL as key */
+		insert_jsonb_key(state, "label");
+
+		/* LABEL's value is an object */
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+		if (elem->defnamespace != NULL)
+		{
+			appendStringInfoString(&labelfmt, "%{schema}I.");
+			new_jsonb_VA(state, NULL, true, 1, "schema", jbvString, elem->defnamespace);
+		}
+
+		appendStringInfoString(&labelfmt, "%{label}I");
+		new_jsonb_VA(state, NULL, true, 1, "label", jbvString, elem->defname);
+
+		fmt_to_jsonb_element(state, labelfmt.data);
+		pfree(labelfmt.data);
 
-	return new_object_object(ret);
+		pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+	}
+
+	/* VALUE */
+	if (!is_reset)
+	{
+		appendStringInfoString(&fmtStr, " = %{value}L");
+		new_jsonb_VA(state, NULL, true, 1, "value", jbvString,
+					 elem->arg ? defGetString(elem) :
+					 defGetBoolean(elem) ? "TRUE" : "FALSE");
+	}
+
+	fmt_to_jsonb_element(state, fmtStr.data);
+	pfree(fmtStr.data);
+
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
- * Deparse the sequence START WITH option.
+ * Deparse SET/RESET as used by
+ * ALTER TABLE ... ALTER COLUMN ... SET/RESET (...)
  *
  * Verbose syntax
- * SET START WITH %{value}s
- * OR
- * START WITH %{value}s
+ * ALTER COLUMN %{column}I RESET|SET (%{options:, }s)
  */
-static inline ObjElem *
-deparse_Seq_Startwith(Form_pg_sequence seqdata, bool alter_table)
+static void
+deparse_ColumnSetOptions_ToJsonb(JsonbParseState *state, AlterTableCmd *subcmd)
 {
-	ObjTree    *ret;
-	char	   *fmt;
+	ListCell   *cell;
+	bool		is_reset = subcmd->subtype == AT_ResetOptions;
+	bool		elem_found PG_USED_FOR_ASSERTS_ONLY = false;
 
-	fmt = alter_table ? "SET START WITH %{value}s" : "START WITH %{value}s";
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	new_jsonb_VA(state,
+				 "ALTER COLUMN %{column}I %{option}s (%{options:, }s)", true, 2,
+				 "column", jbvString, subcmd->name,
+				 "option", jbvString, is_reset ? "RESET" : "SET");
+
+	insert_jsonb_key(state, "options");
+	pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+
+	foreach(cell, (List *) subcmd->def)
+	{
+		DefElem    *elem;
+
+		elem = (DefElem *) lfirst(cell);
+		deparse_DefElem_ToJsonb(state, elem, is_reset);
 
-	ret = new_objtree_VA(fmt, 2,
-						 "clause", ObjTypeString, "start",
-						 "value", ObjTypeString,
-						 psprintf(INT64_FORMAT, seqdata->seqstart));
+#ifdef USE_ASSERT_CHECKING
+		elem_found = true;
+#endif
+	}
+
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+
+	Assert(elem_found);
 
-	return new_object_object(ret);
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
- * Subroutine for CREATE TABLE deparsing.
- *
- * Deal with all the table elements (columns and constraints).
+ * Deparse SET/RESET as used by ALTER TABLE ... SET/RESET (...)
  *
- * Note we ignore constraints in the parse node here; they are extracted from
- * system catalogs instead.
+ * Verbose syntax
+ * RESET|SET (%{options:, }s)
  */
-static List *
-deparse_TableElements(Relation relation, List *tableElements, List *dpcontext,
-					  bool typed, bool composite)
+static void
+deparse_RelSetOptions_toJsonb(JsonbParseState *state, AlterTableCmd *subcmd)
 {
-	List	   *elements = NIL;
-	ListCell   *lc;
+	ListCell   *cell;
+	bool		is_reset = subcmd->subtype == AT_ResetRelOptions;
+	bool		elem_found PG_USED_FOR_ASSERTS_ONLY = false;
 
-	foreach(lc, tableElements)
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	new_jsonb_VA(state, "%{set_reset}s (%{options:, }s)", true, 1,
+				 "set_reset", jbvString, is_reset ? "RESET" : "SET");
+
+	/* insert options array */
+	insert_jsonb_key(state, "options");
+
+	pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+
+	foreach(cell, (List *) subcmd->def)
 	{
-		Node	   *elt = (Node *) lfirst(lc);
+		DefElem    *elem;
 
-		switch (nodeTag(elt))
-		{
-			case T_ColumnDef:
-				{
-					ObjTree    *tree;
-
-					tree = typed ?
-						deparse_ColumnDef_typed(relation, dpcontext,
-												(ColumnDef *) elt) :
-						deparse_ColumnDef(relation, dpcontext,
-										  composite, (ColumnDef *) elt,
-										  false, NULL);
-					if (tree != NULL)
-						elements = lappend(elements, new_object_object(tree));
-				}
-				break;
-			case T_Constraint:
-				break;
-			default:
-				elog(ERROR, "invalid node type %d", nodeTag(elt));
-		}
+		elem = (DefElem *) lfirst(cell);
+		deparse_DefElem_ToJsonb(state, elem, is_reset);
+
+#ifdef USE_ASSERT_CHECKING
+		elem_found = true;
+#endif
 	}
 
-	return elements;
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+
+	Assert(elem_found);
+
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
- * Deparse a CreateSeqStmt.
- *
- * Given a sequence OID and the parse tree that created it, return an ObjTree
- * representing the creation command.
- *
- * Note: We need to deparse the CREATE SEQUENCE command for the TABLE
- * commands. For example, When creating a table, if we specify a column as a
- * sequence type, then we will create a sequence for that column and set that
- * sequence OWNED BY the table.
- *
- * Verbose syntax
- * CREATE %{persistence}s SEQUENCE %{identity}D %{definition: }s
+ * Deparse WITH clause, as used by Create Table.
  */
-static ObjTree *
-deparse_CreateSeqStmt(Oid objectId, Node *parsetree)
+static void
+deparse_withObj_ToJsonb(JsonbParseState *state, char *fmt, CreateStmt *node)
 {
-	ObjTree    *ret;
-	Relation	relation;
-	List	   *elems = NIL;
-	Form_pg_sequence seqform;
-	Sequence_values *seqvalues;
-	CreateSeqStmt *createSeqStmt = (CreateSeqStmt *) parsetree;
-
-	/*
-	 * Only support sequence for IDENTITY COLUMN output separately (via CREATE
-	 * TABLE or ALTER TABLE). Otherwise, return empty here.
-	 */
-	if (createSeqStmt->for_identity)
-		return NULL;
+	ListCell   *cell;
 
-	seqvalues = get_sequence_values(objectId);
-	seqform = seqvalues->seqform;
+	/* with_clause's value is an object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	fmt_to_jsonb_element(state, fmt);
 
-	/* Definition elements */
-	elems = lappend(elems, deparse_Seq_Cache(seqform, false));
-	elems = lappend(elems, deparse_Seq_Cycle(seqform, false));
-	elems = lappend(elems, deparse_Seq_IncrementBy(seqform, false));
-	elems = lappend(elems, deparse_Seq_Minvalue(seqform, false));
-	elems = lappend(elems, deparse_Seq_Maxvalue(seqform, false));
-	elems = lappend(elems, deparse_Seq_Startwith(seqform, false));
-	elems = lappend(elems, deparse_Seq_Restart(seqvalues->last_value));
-	elems = lappend(elems, deparse_Seq_As(seqform));
+	/* WITH */
+	{
+		/* insert with as key */
+		insert_jsonb_key(state, "with");
 
-	/* We purposefully do not emit OWNED BY here */
+		/* with's value is an array */
+		pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
 
-	relation = relation_open(objectId, AccessShareLock);
+		/* add elements to array */
+		foreach(cell, node->options)
+		{
+			DefElem    *opt = (DefElem *) lfirst(cell);
 
-	ret = new_objtree_VA("CREATE %{persistence}s SEQUENCE %{if_not_exists}s %{identity}D %{definition: }s", 4,
-						 "persistence", ObjTypeString,
-						 get_persistence_str(relation->rd_rel->relpersistence),
-						 "if_not_exists", ObjTypeString,
-						 createSeqStmt->if_not_exists ? "IF NOT EXISTS" : "",
-						 "identity", ObjTypeObject,
-						 new_objtree_for_qualname(relation->rd_rel->relnamespace,
-												  RelationGetRelationName(relation)),
-						 "definition", ObjTypeArray, elems);
+			deparse_DefElem_ToJsonb(state, opt, false);
+		}
 
-	relation_close(relation, AccessShareLock);
+		/* with's array end */
+		pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+	}
 
-	return ret;
+	/* with_clause's object end */
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
  * Deparse a CreateStmt (CREATE TABLE).
  *
- * Given a table OID and the parse tree that created it, return an ObjTree
+ * Given a table OID and the parse tree that created it, return JsonbValue
  * representing the creation command.
  *
  * Verbose syntax
  * CREATE %{persistence}s TABLE %{if_not_exists}s %{identity}D [OF
  * %{of_type}T | PARTITION OF %{parent_identity}D] %{table_elements}s
  * %{inherits}s %{partition_by}s %{access_method}s %{with_clause}s
- * %{on_commit}s %{tablespace}s
+ * %{tablespace}s
  */
-static ObjTree *
-deparse_CreateStmt(Oid objectId, Node *parsetree)
+static Jsonb *
+deparse_CreateStmt(Oid objectId, Node *parsetree, char *owner)
 {
 	CreateStmt *node = (CreateStmt *) parsetree;
 	Relation	relation = relation_open(objectId, AccessShareLock);
+	Oid			nspid = relation->rd_rel->relnamespace;
+	char	   *relname = RelationGetRelationName(relation);
 	List	   *dpcontext;
-	ObjTree    *ret;
-	ObjTree    *tmp_obj;
-	List	   *list = NIL;
-	ListCell   *cell;
+	StringInfoData fmtStr;
+	JsonbParseState *state = NULL;
+	bool		telems = false;
+	JsonbValue *value;
 
-	ret = new_objtree_VA("CREATE %{persistence}s TABLE %{if_not_exists}s %{identity}D", 3,
-						 "persistence", ObjTypeString,
-						 get_persistence_str(relation->rd_rel->relpersistence),
-						 "if_not_exists", ObjTypeString,
-						 node->if_not_exists ? "IF NOT EXISTS" : "",
-						 "identity", ObjTypeObject,
-						 new_objtree_for_qualname(relation->rd_rel->relnamespace,
-												  RelationGetRelationName(relation)));
+	initStringInfo(&fmtStr);
 
 	dpcontext = deparse_context_for(RelationGetRelationName(relation),
 									objectId);
 
+	appendStringInfoString(&fmtStr, "CREATE %{persistence}s TABLE %{if_not_exists}s %{identity}D");
+
+	/* mark the start of ROOT object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	/* create owner jsonb element */
+	role_to_jsonb_element(state, owner);
+
+	/* PERSISTENCE and IF NOT EXISTS */
+	new_jsonb_VA(state, NULL, true, 2,
+				 "persistence", jbvString, get_persistence_str(relation->rd_rel->relpersistence),
+				 "if_not_exists", jbvString, node->if_not_exists ? "IF NOT EXISTS" : "");
+
+	/* IDENTITY creation */
+	insert_identity_object(state, nspid, relname);
+
 	/*
+	 * TABLE-ELEMENTS array creation
+	 *
 	 * Typed tables and partitions use a slightly different format string: we
 	 * must not put table_elements with parents directly in the fmt string,
 	 * because if there are no options the parentheses must not be emitted;
@@ -1842,8 +1639,6 @@ deparse_CreateStmt(Oid objectId, Node *parsetree)
 	 */
 	if (node->ofTypename || node->partbound)
 	{
-		List	   *tableelts = NIL;
-
 		/*
 		 * We can't put table elements directly in the fmt string as an array
 		 * surrounded by parentheses here, because an empty clause would cause
